------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Layout_Items.Impl;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Box_Layouts.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QBoxLayout_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QBoxLayout_qt_metacast_wrapper");

   procedure addItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem);
   pragma Import (C, addItem_0_wrapper,
                     "__Qt4Ada_QBoxLayout_addItem_0_wrapper");

   function count_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, count_0_wrapper,
                     "__Qt4Ada_QBoxLayout_count_0_wrapper");

   function hasHeightForWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasHeightForWidth_0_wrapper,
                     "__Qt4Ada_QBoxLayout_hasHeightForWidth_0_wrapper");

   function heightForWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, heightForWidth_0_wrapper,
                     "__Qt4Ada_QBoxLayout_heightForWidth_0_wrapper");

   procedure invalidate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, invalidate_0_wrapper,
                     "__Qt4Ada_QBoxLayout_invalidate_0_wrapper");

   procedure maximumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, maximumSize_0_wrapper,
                     "__Qt4Ada_QBoxLayout_maximumSize_0_wrapper");

   function minimumHeightForWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, minimumHeightForWidth_0_wrapper,
                     "__Qt4Ada_QBoxLayout_minimumHeightForWidth_0_wrapper");

   procedure minimumSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, minimumSize_0_wrapper,
                     "__Qt4Ada_QBoxLayout_minimumSize_0_wrapper");

   procedure sizeHint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, sizeHint_0_wrapper,
                     "__Qt4Ada_QBoxLayout_sizeHint_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QBoxLayout_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QBoxLayout_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QBoxLayout_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QBoxLayout_sender_0_wrapper");

--   ---------------------------------------------------------------------------
--   --! <Subprogram>
--   --!    <Unit> addWidget_wrapper
--   --!    <ImplementationNotes>
--   ---------------------------------------------------------------------------
--   procedure addWidget_wrapper
--    (Self      : not null access Qt_Ada.Internals.Objects.QObject;
--     Widget    : not null access Qt_Ada.Internals.Objects.QObject;
--     Stretch   : Interfaces.C.int;
--     Alignment : Qt4.Alignment);
--   pragma Import
--    (C, addWidget_wrapper, "__Qt4Ada_QBoxLayout_addWidget_wrapper");

--   ---------------------------------------------------------------------------
--   --! <Subprogram>
--   --!    <Unit> Add_Widget
--   --!    <ImplementationNotes>
--   ---------------------------------------------------------------------------
--   procedure Add_Widget
--    (Self      : not null access Q_Box_Layout_Impl;
--     Widget    : not null access Qt4.Widgets.Q_Widget'Class;
--     Stretch   : Interfaces.C.int := 0;
--     Alignment : Qt4.Alignment    := +Align_Default)
--   is
--   begin
--      addWidget_wrapper
--       (Self.Cpp_Object,
--        Qt4.Objects.Impl.Q_Object_Impl'Class (Widget.all).Cpp_Object,
--        Stretch,
--        Alignment);
--   end Add_Widget;

   pragma Style_Checks ("N");

   --------------
   -- Add_Item --
   --------------

   overriding
   procedure Add_Item
    (Self : not null access Q_Box_Layout_Director;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class)
   is
   begin
      addItem_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Qt4.Layout_Items.Impl.Q_Layout_Item_Impl_Base'Class (Item.all).QLayoutItem_View);
   end Add_Item;

   -----------
   -- Count --
   -----------

   overriding
   function Count
    (Self : not null access constant Q_Box_Layout_Director)
       return Qt4.Q_Integer
   is
   begin
      return
        count_0_wrapper
         (Q_Box_Layout_Director'Class (Self.all).QObject_View);
   end Count;

   --------------------------
   -- Has_Height_For_Width --
   --------------------------

   overriding
   function Has_Height_For_Width
    (Self : not null access constant Q_Box_Layout_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasHeightForWidth_0_wrapper
           (Q_Box_Layout_Director'Class (Self.all).QObject_View));
   end Has_Height_For_Width;

   ----------------------
   -- Height_For_Width --
   ----------------------

   overriding
   function Height_For_Width
    (Self : not null access constant Q_Box_Layout_Director;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        heightForWidth_0_wrapper
         (Q_Box_Layout_Director'Class (Self.all).QObject_View,
          W);
   end Height_For_Width;

   ----------------
   -- Invalidate --
   ----------------

   overriding
   procedure Invalidate
    (Self : not null access Q_Box_Layout_Director)
   is
   begin
      invalidate_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View);
   end Invalidate;

   ------------------
   -- Maximum_Size --
   ------------------

   overriding
   function Maximum_Size
    (Self : not null access constant Q_Box_Layout_Director)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      maximumSize_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Maximum_Size;

   ------------------------------
   -- Minimum_Height_For_Width --
   ------------------------------

   overriding
   function Minimum_Height_For_Width
    (Self : not null access constant Q_Box_Layout_Director;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumHeightForWidth_0_wrapper
         (Q_Box_Layout_Director'Class (Self.all).QObject_View,
          W);
   end Minimum_Height_For_Width;

   ------------------
   -- Minimum_Size --
   ------------------

   overriding
   function Minimum_Size
    (Self : not null access constant Q_Box_Layout_Director)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      minimumSize_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Minimum_Size;

   ---------------
   -- Size_Hint --
   ---------------

   overriding
   function Size_Hint
    (Self : not null access constant Q_Box_Layout_Director)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      sizeHint_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Size_Hint;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Box_Layout_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Box_Layout_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Box_Layout_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Box_Layout_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Box_Layout_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Box_Layout_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QBoxLayout", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Box_Layouts.Directors;
